searchNodes=[{"ref":"ExIhdlSubscriptionBase.html","title":"ExIhdlSubscriptionBase","type":"behaviour","doc":"Thin implementation of the ExGcloudPubsubPuller.PullController behaviour. To make use of this module, use it, and implement the callbacks. Examples defmodule MySub do use ExIhdlSubscriptionBase @impl true def moap_module(), do: &quot;hm&quot; @impl true def moap_key(), do: &quot;rssi&quot; @impl true def registry_topic(), do: &quot;some-events-topic&quot; @impl true def subscription_suffix, do: &quot;some-service&quot; @impl true def process_message(%PubsubMessage{data: data}) do log_info(&quot;process_message: \#{inspect(data)}&quot;) cond do do_something(data) -&gt; :ok true -&gt; :error end end end"},{"ref":"ExIhdlSubscriptionBase.html#c:moap_key/0","title":"ExIhdlSubscriptionBase.moap_key/0","type":"callback","doc":"Should return the MOAP key for the desired data. Examples def moap_key(), do: &quot;rssi&quot;"},{"ref":"ExIhdlSubscriptionBase.html#c:moap_module/0","title":"ExIhdlSubscriptionBase.moap_module/0","type":"callback","doc":"Should return the MOAP object under which to look for the MOAP key. Examples def moap_module(), do: &quot;hm&quot;"},{"ref":"ExIhdlSubscriptionBase.html#c:process_message/1","title":"ExIhdlSubscriptionBase.process_message/1","type":"callback","doc":"Gets called with each message received from the ingest pipe. Should return :ok or :error. Examples def process_message(msg), do: something(msg)"},{"ref":"ExIhdlSubscriptionBase.html#c:registry_topic/0","title":"ExIhdlSubscriptionBase.registry_topic/0","type":"callback","doc":"Should return the topic from which all events are sourced. Examples def registry_topic(), do: &quot;staging-eon-registry-events&quot;"},{"ref":"ExIhdlSubscriptionBase.html#c:subscription_suffix/0","title":"ExIhdlSubscriptionBase.subscription_suffix/0","type":"callback","doc":"Should return the suffix to append to the generated subscription, recommended to be unique to this application (e.g. it&#39;s name). Examples def subscription_suffix(), do: &quot;my-app&quot;"},{"ref":"ExIhdlSubscriptionBase.IngestPipe.html","title":"ExIhdlSubscriptionBase.IngestPipe","type":"module","doc":"Convenience functions do do with ingest pipes."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.html#ensure_pipe/1","title":"ExIhdlSubscriptionBase.IngestPipe.ensure_pipe/1","type":"function","doc":"Ensures a pipe exists."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.html#find_subscription/2","title":"ExIhdlSubscriptionBase.IngestPipe.find_subscription/2","type":"function","doc":"From a list of subscriptions, will find the subscription that matches best the given pipe args."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.html#t:pipe_args/0","title":"ExIhdlSubscriptionBase.IngestPipe.pipe_args/0","type":"type","doc":"Minimum necessary information required to create an ingest pipe consisting of a topic and a subscription."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi","type":"module","doc":"Client to wrap interactions with the IngestPipeApi."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#create_pipe/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.create_pipe/4","type":"function","doc":"Creates an ingest pipe consisting of a pubsub topic and pubsub subscription(s)."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#delete/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.delete/3","type":"function","doc":"Issues a DELETE request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#delete!/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.delete!/3","type":"function","doc":"Issues a DELETE request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#get/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.get/3","type":"function","doc":"Issues a GET request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#get!/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.get!/3","type":"function","doc":"Issues a GET request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#head/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.head/3","type":"function","doc":"Issues a HEAD request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#head!/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.head!/3","type":"function","doc":"Issues a HEAD request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#host/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.host/0","type":"function","doc":"The host of the service to fire requests at."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#options/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.options/3","type":"function","doc":"Issues an OPTIONS request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#options!/3","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.options!/3","type":"function","doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#patch/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.patch/4","type":"function","doc":"Issues a PATCH request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#patch!/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.patch!/4","type":"function","doc":"Issues a PATCH request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#port/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.port/0","type":"function","doc":"The port of the service to fire requests at."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#post/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.post/4","type":"function","doc":"Issues a POST request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#post!/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.post!/4","type":"function","doc":"Issues a POST request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_headers/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_headers/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_request_body/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_request_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_body/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_request_headers/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_request_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_headers/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_request_options/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_request_options/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_options/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_request_params/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_request_params/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_params/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_request_url/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_request_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_request_url/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_request_url/2","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_request_url/2","type":"function","doc":""},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_response/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_response/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_response_body/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_response_body/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_body/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_response_chunk/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_response_chunk/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_response_headers/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_response_headers/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_headers/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_response_status_code/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_response_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_status_code/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_status_code/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_status_code/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#process_url/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.process_url/1","type":"function","doc":"Callback implementation for HTTPoison.Base.process_url/1."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#put/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.put/4","type":"function","doc":"Issues a PUT request to the given url. Returns {:ok, response} if the request is successful, {:error, reason} otherwise. See request/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#put!/4","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.put!/4","type":"function","doc":"Issues a PUT request to the given url, raising an exception in case of failure. If the request does not fail, the response is returned. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#request/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.request/1","type":"function","doc":"Issues an HTTP request using a Request struct. This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)"},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#request/5","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.request/5","type":"function","doc":"Issues an HTTP request with the given method to the given url. This function is usually used indirectly by get/3, post/4, put/4, etc Args: method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.) url - target url as a binary string or char list body - request body. See more below headers - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}]) options - Keyword list of options Body: see type HTTPoison.Request Options: see type HTTPoison.Request This function returns {:ok, response} or {:ok, async_response} if the request is successful, {:error, reason} otherwise. Examples request(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])"},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#request!/5","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.request!/5","type":"function","doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure. request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#secure?/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.secure?/0","type":"function","doc":"Determines whether requests are made over HTTP or HTTPS."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#start/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.start/0","type":"function","doc":"Starts HTTPoison and its dependencies."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#stream_next/1","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.stream_next/1","type":"function","doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse. See request!/5 for more detailed information."},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#t:body/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.body/0","type":"type","doc":""},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#t:headers/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.headers/0","type":"type","doc":""},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#t:options/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.options/0","type":"type","doc":""},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#t:params/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.params/0","type":"type","doc":""},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#t:request/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.request/0","type":"type","doc":""},{"ref":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.html#t:url/0","title":"ExIhdlSubscriptionBase.IngestPipe.IngestPipeApi.url/0","type":"type","doc":""},{"ref":"ExIhdlSubscriptionBase.MemoryStore.html","title":"ExIhdlSubscriptionBase.MemoryStore","type":"module","doc":"Barebones in-memory store"},{"ref":"ExIhdlSubscriptionBase.MemoryStore.html#child_spec/1","title":"ExIhdlSubscriptionBase.MemoryStore.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExIhdlSubscriptionBase.MemoryStore.html#load/1","title":"ExIhdlSubscriptionBase.MemoryStore.load/1","type":"function","doc":"Retrieves a value from the MemoryStore, returning nil if the key doesn&#39;t exist."},{"ref":"ExIhdlSubscriptionBase.MemoryStore.html#save/2","title":"ExIhdlSubscriptionBase.MemoryStore.save/2","type":"function","doc":"Saves a value to the MemoryStore, updating it if the key already exists."},{"ref":"ExIhdlSubscriptionBase.MemoryStore.html#start_link/1","title":"ExIhdlSubscriptionBase.MemoryStore.start_link/1","type":"function","doc":"Starts the MemoryStore."},{"ref":"ExIhdlSubscriptionBase.TrackedSchema.html","title":"ExIhdlSubscriptionBase.TrackedSchema","type":"module","doc":""},{"ref":"ExIhdlSubscriptionBase.TrackedSchema.html#enforce_tracked_fields/4","title":"ExIhdlSubscriptionBase.TrackedSchema.enforce_tracked_fields/4","type":"function","doc":""},{"ref":"ExIhdlSubscriptionBase.TrackedSchema.html#last_sent_at_fields/1","title":"ExIhdlSubscriptionBase.TrackedSchema.last_sent_at_fields/1","type":"function","doc":""},{"ref":"ExIhdlSubscriptionBase.TrackedSchema.html#tracked_field_counterpart/2","title":"ExIhdlSubscriptionBase.TrackedSchema.tracked_field_counterpart/2","type":"function","doc":""},{"ref":"ExIhdlSubscriptionBase.TrackedSchema.html#tracked_fields/1","title":"ExIhdlSubscriptionBase.TrackedSchema.tracked_fields/1","type":"function","doc":""}]